#ifndef COMTYPES_H
#define COMTYPES_H
#include <qarray.h>
#include <qstring.h>
#include <qlist.h>
#include <qlistview.h>
#include <ostream.h>

#define TMP_DIR "/tmp/"
#define IPFW_COMMAND "/sbin/ipfw"
typedef struct
{
	int NUMBER;
	QString DESCRIPTION;
} ICMPTYPE_STRUCT;

class FWRule
{
public:
	FWRule();
	~FWRule();
	
	int ac;
	char ** av;
	
//	Rule fields
	int ipfw_number;
	bool ipfw_bprob,ipfw_blogamount,ipfw_not_src,ipfw_not_dst,ipfw_blog;
	double ipfw_matchprob;
	QString ipfw_action;
	unsigned long ipfw_divert_port,ipfw_skipto_rule,ipfw_unreach_code,ipfw_logamount;
	QString ipfw_divert_port_name;
	QString ipfw_fwd_address;
	QString ipfw_protocol;
	QString ipfw_src_address,ipfw_dst_address;
	QString ipfw_src_port,ipfw_dst_port;
	QString ipfw_uid,ipfw_gid,ipfw_direction;
	bool ipfw_option_keepstate,ipfw_option_bridged,ipfw_option_fragment,ipfw_option_ipoptions;
	bool ipfw_option_setup,ipfw_option_established,ipfw_option_tcpflags;
	bool ipfw_option_icmptypes,ipfw_option_tcpoptions;
	QString ipfw_option_keepstate_method,ipfw_option_ipoptions_string;
	QString ipfw_via;
	QString ipfw_option_tcpflags_string,ipfw_option_icmptypes_string;
	QString ipfw_option_tcpoptions_string;
	
//	********************************	
	void dump(ostream & dumpstream);
	void readString(char * pstr);
	QString m_strError;
	QString formRule();
	void clear();
protected:
	void splitArgs(QString & str);
};

void make_error(char * str,FWRule * pRule);
void add(int ac,char ** av,FWRule * pRule);

#endif
