#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/sysctl.h>
#include <net/ethernet.h>
#include <net/if.h>
#include <net/if_var.h>
#include <net/if_dl.h>
#include <net/if_types.h>
#include <net/route.h>

#include <qstring.h>
#include <qstringlist.h>

void print_if_list(QStringList & stringlist)
{
	int mib[6];
	char	name[32];
	int addrcount;
	if_msghdr *ifm, *nextifm;
	ifa_msghdr *ifam;
	sockaddr_dl *sdl;
	char *buf, *lim, *next;
	buf = NULL;
	size_t needed;
	mib[0] = CTL_NET;
	mib[1] = PF_ROUTE;
	mib[2] = 0;
	mib[3] = 0;	/* address family */
	mib[4] = NET_RT_IFLIST;
	mib[5] = 0;
	if (sysctl(mib, 6, NULL, &needed, NULL, 0) < 0)
		goto error_exit;
	if ((buf = (char*)malloc(needed)) == NULL)
		goto error_exit;
	if (sysctl(mib, 6, buf, &needed, NULL, 0) < 0)
		goto error_exit;
	lim = buf + needed;
	next = buf;
	while (next < lim) {

		ifm = (if_msghdr *)next;
		
		if (ifm->ifm_type == RTM_IFINFO) {
			sdl = (sockaddr_dl *)(ifm + 1);
		} else goto error_exit;

		next += ifm->ifm_msglen;
		ifam = NULL;
		addrcount = 0;
		while (next < lim) {

			nextifm = (if_msghdr *)next;

			if (nextifm->ifm_type != RTM_NEWADDR)
				break;

			if (ifam == NULL)
				ifam = (ifa_msghdr *)nextifm;

			addrcount++;
			next += nextifm->ifm_msglen;
		}
		strncpy(name, sdl->sdl_data, sdl->sdl_nlen);
		name[sdl->sdl_nlen] = '\0';
		stringlist.append(QString(name));
	}		

error_exit:
	if (buf != NULL)
		free(buf);
	return;
}


