#ifndef MAINFORM_H
#define MAINFORM_H
#include "mainformbase.H"

class QListView;
class QGridLayout;
class QPixmap;
class QPopupMenu;
class QListViewItem;
class QListBoxItem;
class KernelConfigTab;
class ScriptDialog;

class MainForm : public MainFormBase
{ 
    Q_OBJECT

public:
    MainForm( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~MainForm();
    bool ruleExists(int number);
    
    ScriptDialog * scriptdialog;
    QListView * qlistview_rules;
    QGridLayout * gridlayout_main;
    QGridLayout * gridlayout_main_toolbuttons;
    QGridLayout * gridlayout_tab1;
    QGridLayout * gridlayout_tab_repository;
    QGridLayout * gridlayout_repository_buttons;
    QGridLayout * gridlayout_buttons;
    QGridLayout * gridlayout_movebuttons;
    QPixmap *pixmap_allow,*pixmap_deny,*pixmap_fwd,*pixmap_count;
    QPopupMenu * popupmenu_rules;
    QPopupMenu * popupmenu_repository;
    KernelConfigTab * tab_kernel;

public slots:
     void refreshRules();
	void deleteRule();
	void flushIpfw();
	void editRule();
	void newRule();
	void about();
	void help();
	void createScript();
	void loadRepository();
	void saveRepository();
	void deleteRepositoryRule();
	void clearRepository();
	void addToRepository();
	void editRepositoryRule();
	void newRepositoryRule();
	void activateRepositoryRule();
	void onPopupRules(QListViewItem * pItem,const QPoint& point,int column);
	void onPopupRepository(QListBoxItem * pItem,const QPoint& point);
	void addAllToRepository();
	void activateAllRepositoryRules();
	void moveUp();
	void moveDown();
	void onQuit();
protected:
    void closeEvent(QCloseEvent * e);
};

#endif // MAINFORM_H
