#include <stdlib.h>
#include <qpushbutton.h>
#include <qlistbox.h>
#include <qlayout.h>
#include "optionlistdialog.H"
QString numtostr(int num);
OptionListDialog::OptionListDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "OptionListDialog" );
}

OptionListDialog::~OptionListDialog()
{
}

OptionListDialog::OptionListDialog(QString * items,int numItems, QString selected_item,QWidget* parent = 0, const char* name = 0)
	: QDialog( parent, name, TRUE, 0 )	
{
	if ( !name )
		setName( "OptionListDialog" );
	QPushButton * pushbutton_ok,* pushbutton_cancel;
	
	QGridLayout * gridlayout;
	QGridLayout * gridlayout_buttons;
	resize(300,250);
	setMinimumSize(QSize(300,250)); setMaximumSize(QSize(300,250));
	gridlayout = new QGridLayout(this,1,0,2,5);
	gridlayout_buttons = new QGridLayout(NULL,0,1,2,5);
	gridlayout->addLayout(gridlayout_buttons,1,0);
	listbox_items = new QListBox(this);
	gridlayout->addWidget(listbox_items,0,0);
	pushbutton_ok = new QPushButton("OK",this);
	pushbutton_cancel = new QPushButton("Cancel",this);
	gridlayout_buttons->addWidget(pushbutton_ok,0,0);
	gridlayout_buttons->addWidget(pushbutton_cancel,0,1);
	listbox_items->setSelectionMode(QListBox::Multi);
	int i;
	selected_item = QString(",") + selected_item + QString(",");
	for (i = 0;i < numItems;i++)
	{
		listbox_items->insertItem(items[i]);
		if (selected_item.find(QString(",")+items[i]+QString(",")) != -1)
			listbox_items->setSelected(i,TRUE);
	}
	
	connect(pushbutton_ok,SIGNAL(clicked()),this,SLOT(onOK()));
	connect(pushbutton_cancel,SIGNAL(clicked()),this,SLOT(reject()));
	
}

void OptionListDialog::onOK()
{
	unsigned int i;
	strResult = "";
	for (i = 0;i<listbox_items->count();i++)
	{
		if (listbox_items->isSelected(i))
		{
			strResult+=listbox_items->text(i);
			strResult+=",";
		}
	}
	if (strResult.length()>0)
		strResult.truncate(strResult.length()-1);
	accept();
}


IcmptypeListDialog::IcmptypeListDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "IcmptypeListDialog" );
}

IcmptypeListDialog::~IcmptypeListDialog()
{
}

IcmptypeListDialog::IcmptypeListDialog(_icmpcode * items,int numItems, QString selected_item,QWidget* parent = 0, const char* name = 0)
	: QDialog( parent, name, TRUE, 0 )	
{
	if ( !name )
		setName( "IcmptypeListDialog" );
	QPushButton * pushbutton_ok,* pushbutton_cancel;
	
	QGridLayout * gridlayout;
	QGridLayout * gridlayout_buttons;
	resize(300,250);
	setMinimumSize(QSize(300,250)); setMaximumSize(QSize(300,250));
	gridlayout = new QGridLayout(this,1,0,2,5);
	gridlayout_buttons = new QGridLayout(NULL,0,1,2,5);
	gridlayout->addLayout(gridlayout_buttons,1,0);
	listbox_items = new QListBox(this);
	gridlayout->addWidget(listbox_items,0,0);
	pushbutton_ok = new QPushButton("OK",this);
	pushbutton_cancel = new QPushButton("Cancel",this);
	gridlayout_buttons->addWidget(pushbutton_ok,0,0);
	gridlayout_buttons->addWidget(pushbutton_cancel,0,1);
	listbox_items->setSelectionMode(QListBox::Multi);
	int i;
	selected_item = QString(",") + selected_item + QString(",");
	for (i = 0;i < numItems;i++)
	{
		listbox_items->insertItem(numtostr(items[i].code)+QString(" - ")+QString(items[i].str));
		if (selected_item.find(QString(",")+numtostr(items[i].code)+QString(",")) != -1)
			listbox_items->setSelected(i,TRUE);
	}
	
	connect(pushbutton_ok,SIGNAL(clicked()),this,SLOT(onOK()));
	connect(pushbutton_cancel,SIGNAL(clicked()),this,SLOT(reject()));
	
}

void IcmptypeListDialog::onOK()
{
	unsigned int i;
	strResult = "";
	for (i = 0;i<listbox_items->count();i++)
	{
		if (listbox_items->isSelected(i))
		{
			strResult+=numtostr(atoi(listbox_items->text(i)));
			strResult+=",";
		}
	}
	if (strResult.length()>0)
		strResult.truncate(strResult.length()-1);
	accept();
}
